version: 1
name: full kernel validation for v5.15-rt branch
description: Build and test linux kernel with every toolchain
jobs:
- name: arm-gcc
  builds:
    - build_name: gcc-10-lkftconfig
      target_arch: arm
      toolchain: gcc-10
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM_TI_CPUFREQ=y
        - CONFIG_SERIAL_8250_OMAP=y
        - CONFIG_POSIX_MQUEUE=y
        - CONFIG_OF=y
        - CONFIG_SYN_COOKIES=y
- name: arm-gcc-preemption-lowlatency
  builds:
    - build_name: gcc-10-lkftconfig-preemption-lowlatency
      target_arch: arm
      toolchain: gcc-10
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM_TI_CPUFREQ=y
        - CONFIG_SERIAL_8250_OMAP=y
        - CONFIG_POSIX_MQUEUE=y
        - CONFIG_OF=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_CPU_FREQ=n
- name: arm-gcc-preemption-preempt-none
  builds:
    - build_name: gcc-10-lkftconfig-preemption-preempt-none
      target_arch: arm
      toolchain: gcc-10
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM_TI_CPUFREQ=y
        - CONFIG_SERIAL_8250_OMAP=y
        - CONFIG_POSIX_MQUEUE=y
        - CONFIG_OF=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_NONE=y
        - CONFIG_CPU_FREQ=n
- name: arm-gcc-preemption-rt
  builds:
    - build_name: gcc-10-lkftconfig-preemption-rt
      target_arch: arm
      toolchain: gcc-10
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM_TI_CPUFREQ=y
        - CONFIG_SERIAL_8250_OMAP=y
        - CONFIG_POSIX_MQUEUE=y
        - CONFIG_OF=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_KVM=n  # >= v5.10
        - CONFIG_PREEMPT_RT=y
        - CONFIG_PREEMPT_RT_FULL=y  # <= v4.19
        - CONFIG_CPU_FREQ=n
- name: arm-gcc-preemption-voluntary
  builds:
    - build_name: gcc-10-lkftconfig-preemption-voluntary
      target_arch: arm
      toolchain: gcc-10
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM_TI_CPUFREQ=y
        - CONFIG_SERIAL_8250_OMAP=y
        - CONFIG_POSIX_MQUEUE=y
        - CONFIG_OF=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_VOLUNTARY=y
        - CONFIG_CPU_FREQ=n
- name: arm64-gcc
  builds:
    - build_name: gcc-11-lkftconfig
      target_arch: arm64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM64_MODULE_PLTS=y
        - CONFIG_SYN_COOKIES=y
- name: arm64-gcc-preemption-lowlatency
  builds:
    - build_name: gcc-11-lkftconfig-preemption-lowlatency
      target_arch: arm64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM64_MODULE_PLTS=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_CPU_FREQ=n
- name: arm64-gcc-preemption-preempt-none
  builds:
    - build_name: gcc-11-lkftconfig-preemption-preempt-none
      target_arch: arm64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM64_MODULE_PLTS=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_NONE=y
        - CONFIG_CPU_FREQ=n
- name: arm64-gcc-preemption-rt
  builds:
    - build_name: gcc-11-lkftconfig-preemption-rt
      target_arch: arm64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM64_MODULE_PLTS=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_KVM=n  # >= v5.10
        - CONFIG_PREEMPT_RT=y
        - CONFIG_PREEMPT_RT_FULL=y  # <= v4.19
        - CONFIG_CPU_FREQ=n
- name: arm64-gcc-preemption-voluntary
  builds:
    - build_name: gcc-11-lkftconfig-preemption-voluntary
      target_arch: arm64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_ARM64_MODULE_PLTS=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_VOLUNTARY=y
        - CONFIG_CPU_FREQ=n
- name: i386-gcc
  builds:
    - build_name: gcc-11-lkftconfig
      target_arch: i386
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
- name: i386-gcc-preemption-lowlatency
  builds:
    - build_name: gcc-11-lkftconfig-preemption-lowlatency
      target_arch: i386
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_CPU_FREQ=n
- name: i386-gcc-preemption-preempt-none
  builds:
    - build_name: gcc-11-lkftconfig-preemption-preempt-none
      target_arch: i386
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_NONE=y
        - CONFIG_CPU_FREQ=n
- name: i386-gcc-preemption-rt
  builds:
    - build_name: gcc-11-lkftconfig-preemption-rt
      target_arch: i386
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_RT=y
        - CONFIG_PREEMPT_RT_FULL=y  # <= v4.19
        - CONFIG_SCHED_MC_PRIO=n
        - CONFIG_CPU_FREQ=n
- name: i386-gcc-preemption-voluntary
  builds:
    - build_name: gcc-11-lkftconfig-preemption-voluntary
      target_arch: i386
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_VOLUNTARY=y
        - CONFIG_CPU_FREQ=n
- name: x86-gcc
  builds:
    - build_name: gcc-11-lkftconfig
      target_arch: x86_64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
- name: x86-gcc-preemption-lowlatency
  builds:
    - build_name: gcc-11-lkftconfig-preemption-lowlatency
      target_arch: x86_64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_CPU_FREQ=n
- name: x86-gcc-preemption-preempt-none
  builds:
    - build_name: gcc-11-lkftconfig-preemption-preempt-none
      target_arch: x86_64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_NONE=y
        - CONFIG_CPU_FREQ=n
- name: x86-gcc-preemption-rt
  builds:
    - build_name: gcc-11-lkftconfig-preemption-rt
      target_arch: x86_64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_RT=y
        - CONFIG_PREEMPT_RT_FULL=y  # <= v4.19
        - CONFIG_SCHED_MC_PRIO=n
        - CONFIG_CPU_FREQ=n
- name: x86-gcc-preemption-voluntary
  builds:
    - build_name: gcc-11-lkftconfig-preemption-voluntary
      target_arch: x86_64
      toolchain: gcc-11
      kconfig:
        - defconfig
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/lkft-crypto.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/distro-overrides.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/systemd.config
        - https://raw.githubusercontent.com/Linaro/meta-lkft/kirkstone/meta/recipes-kernel/linux/files/virtio.config
        - CONFIG_IGB=y
        - CONFIG_UNWINDER_FRAME_POINTER=y
        - CONFIG_SYN_COOKIES=y
        - CONFIG_NO_HZ=y
        - CONFIG_EXPERT=y
        - CONFIG_PREEMPT_VOLUNTARY=y
        - CONFIG_CPU_FREQ=n
